#include "Winsock2.h"
#include "Windows.h"
#include "scripts.h"
#include "engine.h"

extern "C" 
{
	#include "LuaLib\lua.h"
	#include "LuaLib\lualib.h"
	#include "LuaLib\lauxlib.h"
}
#define lspop lua_tostring
#define lnpop lua_tonumber
#define lpushn lua_pushnumber
#define lpushs lua_pushstring
#define CCS const char *

#include "Misc.h"
#include "LuaManager.h"
#include "Lua_Class.h"
#include "time.h"


#pragma warning(disable: 4244 4291)

int Get_ID(GameObject *O)
{
	if(O)
	{
		return Commands->Get_ID(O);	
	}
	return 0;
}

int Lua_Get_ID(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lua_pushnumber(L, Get_ID(Commands->Find_Object(lua_tonumber(L, 1))));
	return 0;
}

int Lua_Console_Input(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Console_Input(lua_tostring(L, 1));	
	return 0;
}

int Lua_Console_Output(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Console_Output(lua_tostring(L, 1));
	return 0;
}

int Lua_Get_Definition_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lua_pushstring(L, Get_Definition_Name(lua_tonumber(L, 1)));
	return 1;
}
int Lua_Get_Definition_ID(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 1;
	}
	lua_pushnumber(L, Get_Definition_ID(lua_tostring(L, 1)));
	return 1;
}
int Lua_Get_Definition_Class_ID(lua_State *L) 
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lua_pushnumber(L, Get_Definition_Class_ID(lua_tostring(L, 1)));
	return 1;
}
int Lua_Is_Valid_Preset_ID(lua_State *L) 
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lua_pushnumber(L, Is_Valid_Preset_ID(lua_tonumber(L, 1)));
	return 1;
}
int Lua_Is_Valid_Preset(lua_State *L) 
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lua_pushnumber(L, Is_Valid_Preset(lua_tostring(L, 1)));
	return 1;
}
int Lua_Set_Max_Health(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Max_Health(Commands->Find_Object(lnpop(L, 1)), lua_tonumber(L, 2));
	return 0;
}
int Lua_Set_Max_Shield_Strength(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Max_Shield_Strength(Commands->Find_Object(lnpop(L, 1)), lua_tonumber(L, 2));
	return 0;
}
int Lua_Get_Shield_Type(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lua_pushstring(L, Get_Shield_Type(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Skin(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lua_pushstring(L, Get_Skin(Commands->Find_Object(lnpop(L, 1))));
	return 0;
}
int Lua_Set_Skin(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Skin(Commands->Find_Object(lnpop(L, 1)), lua_tostring(L, 2));
	return 0;
}
int Lua_Power_Base(lua_State *L) 
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Power_Base(lua_tonumber(L, 1), lua_tonumber(L, 2));
	return 0;
}
int Lua_Set_Can_Generate_Soldiers(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Can_Generate_Soldiers(lua_tonumber(L, 1), lua_tonumber(L, 2));
	return 0;
}
int Lua_Set_Can_Generate_Vehicles(lua_State *L) 
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Can_Generate_Vehicles(lua_tonumber(L, 1), lua_tonumber(L, 2));
	return 0;
}
int Lua_Destroy_Base(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Destroy_Base(lua_tonumber(L, 1));
	return 0;
}
int Lua_Beacon_Destroyed_Base(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Beacon_Destroyed_Base(lua_tonumber(L, 1), lua_tonumber(L, 2));
	return 0;
}
int Lua_Enable_Base_Radar(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Enable_Base_Radar(lnpop(L, 1), lnpop(L, 2));
	return 0;
}
int Lua_Is_Harvester(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Harvester(Commands->Find_Object(lnpop(L, 1))));
	return 0;
}
int Lua_Is_Radar_Enabled(lua_State *L) 
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Radar_Enabled(lnpop(L, 1)));
	return 1;
}
int Lua_Building_Type(lua_State *L) 
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Building_Type(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Building_Dead(lua_State *L) 
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Building_Dead(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Find_Building(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Building(lnpop(L, 1), lnpop(L, 2)))); 
	return 1;
}
int Lua_Find_Base_Defense(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Base_Defense(lnpop(L, 1)))); 
	return 1;
}
int Lua_Is_Map_Flying(lua_State *L) 
{
	lpushn(L, Is_Map_Flying());
	return 0;
}
int Lua_Find_Harvester(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Harvester(lnpop(L, 1)))); 
	return 0;
}
int Lua_Is_Base_Powered(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Base_Powered(lnpop(L, 1)));
	return 1;
}
int Lua_Can_Generate_Vehicles(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Can_Generate_Vehicles(lnpop(L, 1)));
	return 1;
}
int Lua_Can_Generate_Soliders(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Can_Generate_Soliders(lnpop(L, 1)));
	return 1;
}
/*
int Lua_The_Game(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_The_Skirmish_Game(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_The_Cnc_Game(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_The_Single_Player_Game(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
*/
int Lua_Is_A_Building(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_A_Building(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Building_Count_Team(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Building_Count_Team(lnpop(L, 1)));
	return 0;
}

int Lua_Find_Building_By_Team(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Building_By_Team(lnpop(L, 1))));
	return 1;
}
int Lua_Find_Building_By_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Building_By_Team(lnpop(L, 1))));
	return 1;
}
int Lua_Find_Power_Plant(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Power_Plant(lnpop(L, 1))));
	return 1;
}
int Lua_Find_Refinery(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Refinery(lnpop(L, 1))));
	return 1;
}
int Lua_Find_Repair_Bay(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Repair_Bay(lnpop(L, 1))));
	return 1;
}
int Lua_Find_Soldier_Factory(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Soldier_Factory(lnpop(L, 1))));
	return 1;
}
int Lua_Find_Airstrip(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Airstrip(lnpop(L, 1))));
	return 1;
}
int Lua_Find_War_Factory(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_War_Factory(lnpop(L, 1))));
	return 1;
}
int Lua_Find_Vehicle_Factory(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Vehicle_Factory(lnpop(L, 1))));
	return 1;
}
int Lua_Find_Com_Center(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Com_Center(lnpop(L, 1))));
	return 0;
}
int Lua_Is_Gameplay_Permitted(lua_State *L)
{
	lpushn(L, Is_Gameplay_Permitted());
	return 1;
}
int Lua_Is_Dedicated(lua_State *L) 
{
	lpushn(L, Is_Dedicated());
	return 1;
}
int Lua_Is_Linux(lua_State *L)
{
	lpushn(L, Is_Linux());
	return 1;
}
int Lua_Get_Current_Game_Mode(lua_State *L)
{
	lpushn(L, Get_Current_Game_Mode());
	return 1;
}
int Lua_Get_Harvester_Preset_ID(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Harvester_Preset_ID(lnpop(L, 1)));
	return 1;
}
int Lua_Is_Harvester_Preset(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Harvester_Preset(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Destroy_Connection(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Destroy_Connection(lnpop(L, 1));
	return 0;
}
int Lua_Get_IP_Address(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *IP = Get_IP_Address(lnpop(L, 1));
	if(!IP)
	{
		return 0;
	}
	lpushs(L, IP);
	delete []IP;
	return 1;
}
int Lua_Get_IP_Port(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *IP = Get_IP_Port(lnpop(L, 1));
	if(!IP)
	{
		return 0;
	}
	lpushs(L, IP);
	delete []IP;
	return 1;
}
int Lua_Get_Bandwidth(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Bandwidth(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Ping(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Ping(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Kbits(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Kbits(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Object_Type(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Object_Type(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Set_Object_Type(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Object_Type(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	return 0;
}
int Lua_Is_Building(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Building(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Soldier(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Soldier(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Vehicle(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Vehicle(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Cinematic(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Cinematic(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_ScriptZone(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_ScriptZone(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Powerup(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Powerup(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_C4(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_C4(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Beacon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Beacon(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Armed(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Armed(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Simple(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Simple(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_PowerPlant(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_PowerPlant(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_SoldierFactory(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_SoldierFactory(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_VehicleFactory(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_VehicleFactory(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Airstrip(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Airstrip(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_WarFactory(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_WarFactory(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Refinery(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Refinery(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_ComCenter(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_ComCenter(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_RepairBay(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_RepairBay(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Scriptable(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Scriptable(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Building_Type(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushs(L, Get_Building_Type(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Object_Count(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Object_Count(lnpop(L, 2), lspop(L, 1)));
	return 1;
}
/*
int Lua_Find_Nearest_Preset(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}
	return 0;
}
*/
int Lua_Find_Random_Preset(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Random_Preset(lspop(L, 1), lnpop(L, 2), lnpop(L, 2))));
	return 1;
}
int Lua_Send_Custom_To_Team_Buildings(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 5)
	{
		return 0;
	}
	Send_Custom_To_Team_Buildings(lnpop(L, 1), Commands->Find_Object(lnpop(L, 2)), lnpop(L, 3), lnpop(L,3), lnpop(L, 4));
	return 0;
}
int Lua_Send_Custom_To_Team_Preset(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 6)
	{
		return 0;
	}
	Send_Custom_To_Team_Preset(lnpop(L, 1), lspop(L, 2), Commands->Find_Object(lnpop(L, 3)), lnpop(L, 4), lnpop(L, 5), lnpop(L, 6));
	return 0;
}
/*
int Lua_Send_Custom_All_Objects_Area(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
*/
int Lua_Send_Custom_All_Objects(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Send_Custom_All_Objects(lnpop(L, 1), Commands->Find_Object(lnpop(L, 2)), lnpop(L, 3));
	return 0;
}
int Lua_Send_Custom_Event_To_Object(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 5)
	{
		return 0;
	}
	Send_Custom_Event_To_Object(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2), lnpop(L, 3), lnpop(L, 4), lnpop(L, 5));
	return 0;
}
/*
int Lua_Is_Unit_In_Range(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
*/

int Lua_Get_Is_Powerup_Persistant(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Is_Powerup_Persistant(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Set_Is_Powerup_Persistant(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Is_Powerup_Persistant(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	return 0;
}
int Lua_Get_Powerup_Always_Allow_Grant(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Powerup_Always_Allow_Grant(Commands->Find_Object(lnpop(L, 1))));
	return 0;
}
int Lua_Set_Powerup_Always_Allow_Grant(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Powerup_Always_Allow_Grant(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	return 0;
}
int Lua_Get_Powerup_Grant_Sound(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Powerup_Grant_Sound(Commands->Find_Object(lnpop(L, 1))));
	return 1;	
}
int Lua_Set_Powerup_Grant_Sound(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Powerup_Grant_Sound(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	return 0;
}
int Lua_Grant_Powerup(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Grant_Powerup(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2));
	return 0;
}
int Lua_Get_Vehicle(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_Vehicle(Commands->Find_Object(lnpop(L, 1)))));
	return 1;
}
int Lua_Grant_Refill(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Grant_Refill(Commands->Find_Object(lnpop(L, 1)));
	return 0;
}
int Lua_Change_Character(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Change_Character(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2)));
	return 1;
}
int Lua_Create_Vehicle(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	Create_Vehicle(lspop(L, 4), lnpop(L, 3), Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)); 
	return 0;
}
int Lua_Toggle_Fly_Mode(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Toggle_Fly_Mode(Commands->Find_Object(lnpop(L, 1)));
	return 0;
}
int Lua_Get_Vehicle_Occupant_Count(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Vehicle_Occupant_Count(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Vehicle_Occupant(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_Vehicle_Occupant(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2))));
	return 1;
}
int Lua_Get_Vehicle_Driver(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_Vehicle_Driver(Commands->Find_Object(lnpop(L, 1)))));
	return 1;
}
int Lua_Get_Vehicle_Gunner(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_Vehicle_Gunner(Commands->Find_Object(lnpop(L, 1)))));
	return 1;
}
int Lua_Force_Occupant_Exit(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Force_Occupant_Exit(Commands->Find_Object(lnpop(L, 2)), lnpop(L, 1));
	return 0;
}
int Lua_Force_Occupants_Exit(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Force_Occupants_Exit(Commands->Find_Object(lnpop(L, 1)));
	return 0;
}
int Lua_Get_Vehicle_Return(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_Vehicle_Return(Commands->Find_Object(lnpop(L, 1)))));
	return 1;
}
int Lua_Is_Stealth(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Stealth(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Fly_Mode(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Fly_Mode(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Vehicle_Seat_Count(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Vehicle_Seat_Count(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Spawn_Char(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushs(L, Get_Spawn_Char(lnpop(L, 1)));
	return 1;
}
int Lua_Change_Spawn_Char(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Change_Spawn_Char(lnpop(L, 2), lspop(L, 1));
	return 0;
}
int Lua_Soldier_Transition_Vehicle(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Soldier_Transition_Vehicle(Commands->Find_Object(lnpop(L, 1)));
	return 0;
}
int Lua_Get_Vehicle_Mode(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Vehicle_Mode(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Team_Vehicle_Count(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Team_Vehicle_Count(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Vehicle_Owner(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_Vehicle_Owner(Commands->Find_Object(lnpop(L, 1)))));
	return 1;
}
int Lua_Force_Occupants_Exit_Team(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Force_Occupants_Exit_Team(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	return 0;
}
int Lua_Get_Vehicle_Definition_Mode(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Vehicle_Definition_Mode(lspop(L, 1)));
	return 1;
}

/*
int Lua_Find_Closest_Zone(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
*/
int Lua_IsInsideZone(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, IsInsideZone(Commands->Find_Object(lnpop(L, 1)), Commands->Find_Object(lnpop(L, 2))));
	return 1;
}
int Lua_Get_Vehicle_Definition_Mode_By_ID(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Vehicle_Definition_Mode_By_ID(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Zone_Type(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Zone_Type(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
/*
int Lua_Get_Zone_Box(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_Set_Zone_Box(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_Create_Zone(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_PointInZone(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_Overlap_Test(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
*/
int Lua_IsAvailableForPurchase(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, IsAvailableForPurchase(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Check_Transitions(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Check_Transitions(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)));
	return 1;
}
int Lua_Get_Vehicle_Gunner_Pos(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_Vehicle_Gunner_Pos(Commands->Find_Object(lnpop(L, 1)))));
	return 1;
}
int Lua_Set_Vehicle_Is_Visible(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Vehicle_Is_Visible(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	return 0;
}
int Lua_Set_Vehicle_Gunner(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Vehicle_Gunner(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	return 0;
}
int Lua_Get_Model(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushs(L, Get_Model(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Animation_Frame(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Animation_Frame(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_TrackedVehicle(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_TrackedVehicle(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_VTOLVehicle(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_VTOLVehicle(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_WheeledVehicle(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_WheeledVehicle(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Motorcycle(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Motorcycle(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Door(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Door(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Elevator(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Elevator(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_DamageableStaticPhys(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_DamageableStaticPhys(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_AccessablePhys(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_AccessablePhys(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_DecorationPhys(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_DecorationPhys(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_HumanPhys(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_HumanPhys(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_MotorVehicle(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_MotorVehicle(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Phys3(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Phys3(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_RigidBody(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_RigidBody(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_ShakeableStatricPhys(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_ShakeableStatricPhys(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_StaticAnimPhys(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_StaticAnimPhys(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_StaticPhys(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_StaticPhys(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_TimedDecorationPhys(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_TimedDecorationPhys(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_VehiclePhys(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_VehiclePhys(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_DynamicAnimPhys(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_DynamicAnimPhys(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_BuildingAggregate(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_BuildingAggregate(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Is_Projectile(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Is_Projectile(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Physics(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushs(L, Get_Physics(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Copy_Transform(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Copy_Transform(Commands->Find_Object(lnpop(L, 1)), Commands->Find_Object(lnpop(L, 2)));
	return 0;
}
int Lua_Get_Mass(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Mass(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Htree_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushs(L, Get_Htree_Name(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Sex(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Sex(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
/*
int Lua_Create_Effect_All_Stealthed_Objects_Area(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}
	return 0;
}
*/
int Lua_Create_Effect_All_Of_Preset(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	Create_Effect_All_Of_Preset(lspop(L, 1), lspop(L, 2),  lnpop(L, 3), lnpop(L, 4));
	return 0;
}
int Lua_Get_GameObj(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_GameObj(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Player_ID(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Player_ID(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Player_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *ptr = Get_Player_Name(Commands->Find_Object(lnpop(L, 1)));
	if(!ptr)
	{
		return 0;
	}
	lpushs(L, ptr);
	delete []ptr;
	return 1;
}
int Lua_Get_Player_Name_By_ID(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *ptr = Get_Player_Name_By_ID(lnpop(L, 1));
	if(!ptr)
	{
		return 0;
	}
	lpushs(L, ptr);
	delete []ptr;
	return 1;
}
int Lua_Change_Team(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Change_Team(Commands->Find_Object(lnpop(L, 2)), lnpop(L, 1));
	return 0;
}
int Lua_Change_Team_By_ID(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Change_Team_By_ID(lnpop(L, 2), lnpop(L, 1));
	return 0;
}
int Lua_Get_Player_Count(lua_State *L)
{
	lpushn(L, Get_Player_Count());
	return 1;
}
int Lua_Get_Team_Player_Count(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Team_Player_Count(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Team(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Team(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Rank(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Rank(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Kills(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Kills(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Deaths(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Deaths(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Score(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Score(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Money(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Money(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Kill_To_Death_Ratio(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Kill_To_Death_Ratio(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Part_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Rank(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Part_Names(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Part_Names(lspop(L, 1)));
	return 1;
}
/*
int Lua_Get_Team_Color(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}
	return 0;
}
int Lua_Get_Player_Color(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
*/

int Lua_Get_GameObj_By_Player_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_GameObj_By_Player_Name(lspop(L, 1))));
	return 1;
}
int Lua_Purchase_Item(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Purchase_Item(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)));
	return 1;
}
int Lua_Set_Ladder_Points(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Ladder_Points(lnpop(L,1), lnpop(L,2));
	return 0;
}
int Lua_Set_Rung(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Rung(lnpop(L, 1), lnpop(L, 3));
	return 0;
}
int Lua_Set_Money(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Money(lnpop(L, 1), lnpop(L, 2));
	return 0;
}
int Lua_Set_Score(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Score(lnpop(L, 1), lnpop(L, 2));
	return 0;
}
int Lua_Find_First_Player(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_First_Player(lnpop(L, 1))));
	return 1;
}
int Lua_Change_Player_Team(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	lpushn(L, Change_Player_Team(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2), lnpop(L, 3), lnpop(L, 4)));
	return 1;
}
int Lua_Tally_Team_Size(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Tally_Team_Size(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Team_Score(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Team_Score(lnpop(L, 1)));
	return 1;
}
int Lua_Send_Custom_All_Players(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	 Send_Custom_All_Players(lnpop(L, 1), Commands->Find_Object(lnpop(L, 2)), lnpop(L, 3));
	return 0;
}
int Lua_Steal_Team_Credits(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Steal_Team_Credits(lnpop(L, 1), lnpop(L, 2)));
	return 1;
}
int Lua_Get_Team_Credits(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Team_Credits(lnpop(L, 1)));
	return 1;
}
int Lua_Change_Team_2(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Change_Team_2(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	return 0;
}
int Lua_Get_Player_Type(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Player_Type(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Team_Cost(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Team_Cost(lspop(L, 1), lnpop(L, 2)));
	return 1;
}
int Lua_Get_Cost(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Cost(lspop(L, 1)));
	return 1;
}
int Lua_Set_Enlisted(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 5)
	{
		return 0;
	}
	Set_Enlisted(lnpop(L, 1), lnpop(L, 2), lnpop(L, 3), lnpop(L, 4), lspop(L, 5));
	return 0;
}
int Lua_Set_Beacon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 5)
	{
		return 0;
	}
	Set_Beacon(lnpop(L, 1), lnpop(L, 2), lnpop(L, 3), lnpop(L, 4), lspop(L, 5));
	return 0;
}
int Lua_Set_Refill(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Set_Refill(lnpop(L, 1), lnpop(L, 2), lspop(L, 3));
	return 0;
}
int Lua_Set_Preset(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 7)
	{
		return 0;
	}
	Set_Preset(lnpop(L, 1), lnpop(L, 2), lnpop(L, 3), lnpop(L, 4), lnpop(L, 5), lnpop(L, 6), lspop(L, 7));
	return 0;
}
int Lua_Set_Alternate(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 6)
	{
		return 0;
	}
	Set_Alternate(lnpop(L, 1), lnpop(L, 2), lnpop(L, 3), lnpop(L, 4), lnpop(L, 5), lspop(L, 6));
	return 0;
}
int Lua_Disable_Enlisted(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Disable_Enlisted(lnpop(L, 1), lnpop(L, 2));
	return 0;
}
int Lua_Disable_Preset(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Disable_Preset(lnpop(L, 1), lnpop(L, 2), lnpop(L, 3));
	return 0;
}
int Lua_Disable_Enlisted_By_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Disable_Enlisted_By_Name(lnpop(L, 1), lspop(L, 2));
	return 0;
}
int Lua_Disable_Preset_By_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Disable_Preset_By_Name(lnpop(L, 1), lspop(L, 2));
	return 0;
}
int Lua_Disable_All_Ground_Vehicles(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Disable_All_Ground_Vehicles(lnpop(L, 1));
	return 0;
}
int Lua_Disable_All_Flying_Vehicles(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Disable_All_Flying_Vehicles(lnpop(L, 1));
	return 0;
}
int Lua_Get_Team_Icon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushs(L, Get_Team_Icon(lspop(L, 1), lnpop(L, 2)));
	return 1;
}
int Lua_Get_Icon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushs(L, Get_Icon(lspop(L, 1)));
	return 1;
}
int Lua_Remove_Script(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Remove_Script(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2));
	return 0;
}
int Lua_Remove_All_Scripts(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Remove_All_Scripts(Commands->Find_Object(lnpop(L, 1)));
	return 0;
}
int Lua_Attach_Script_Preset(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	 Attach_Script_Preset(lspop(L, 1), lspop(L, 2), lspop(L, 3), lnpop(L, 4));
	return 0;
}
int Lua_Attach_Script_Type(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	Attach_Script_Type(lspop(L, 1), lspop(L, 2), lnpop(L, 3), lnpop(L, 4));
	return 0;
}
int Lua_Remove_Script_Preset(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Remove_Script_Preset(lspop(L, 1), lspop(L, 2), lnpop(L, 3));
	return 0;
}
int Lua_Remove_Script_Type(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	 Remove_Script_Type(lspop(L, 1), lnpop(L, 2), lnpop(L, 3));
	return 0;
}
int Lua_Is_Script_Attached(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Is_Script_Attached(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2)));
	return 1;
}
int Lua_Attach_Script_Once(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Attach_Script_Once(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2), lspop(L, 3));
	return 0;
}
int Lua_Attach_Script_Preset_Once(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	Attach_Script_Preset_Once(lspop(L, 1), lspop(L, 2), lspop(L, 3), lnpop(L, 4));	
	return 0;
}
int Lua_Attach_Script_Type_Once(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	Attach_Script_Type_Once(lspop(L, 1), lspop(L, 2), lnpop(L, 3), lnpop(L, 4));
	return 0;
}
int Lua_Attach_Script_Building(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Attach_Script_Building(lspop(L, 1), lspop(L, 2), lnpop(L, 3));
	return 0;
}
int Lua_Attach_Script_Is_Preset(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 5)
	{
		return 0;
	}
	Attach_Script_Is_Preset(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2), lspop(L, 3), lspop(L, 4), lnpop(L, 5));

	return 0;
}
int Lua_Attach_Script_Is_Type(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 5)
	{
		return 0;
	}
	Attach_Script_Is_Type(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2), lspop(L, 3), lspop(L, 4), lnpop(L, 5));
	return 0;
}
int Lua_Attach_Script_Player_Once(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Attach_Script_Player_Once(lspop(L, 1), lspop(L, 2), lnpop(L, 2));
	return 0;
}
int Lua_Remove_Duplicate_Script(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Remove_Duplicate_Script(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2));
	return 0;
}
int Lua_Attach_Script_All_Buildings_Team(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	 Attach_Script_All_Buildings_Team(lnpop(L, 1), lspop(L, 2), lspop(L, 3), lnpop(L, 4));
	return 0;
}
int Lua_Attach_Script_All_Turrets_Team(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	Attach_Script_All_Turrets_Team(lnpop(L, 1), lspop(L, 2), lspop(L, 3), lnpop(L, 4));
	return 0;
}
int Lua_Find_Building_With_Script(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Building_With_Script(lnpop(L, 1), lnpop(L, 2), lspop(L, 3), Commands->Find_Object(lnpop(L, 4)))));
	return 1;
}
int Lua_Find_Object_With_Script(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Object_With_Script(lspop(L, 1))));
	return 1;
}
int Lua_Get_Translated_String(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *ptr = Get_Translated_String(lnpop(L, 1));
	if(!ptr)
	{
		return 0;
	}
	lpushs(L, ptr);
	delete []ptr;
	return 1;
}
int Lua_Get_Translated_Preset_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *ptr = Get_Translated_Preset_Name(Commands->Find_Object(lnpop(L, 1)));
	if(!ptr)
	{
		return 0;
	}
	lpushs(L, ptr);
	delete []ptr;
	return 1;
}
int Lua_Get_Translated_Weapon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	const char *ptr = Get_Translated_Weapon(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	if(!ptr)
	{
		return 0;
	}
	lpushs(L, ptr);
	delete []ptr;
	return 1;
}
int Lua_Get_Current_Translated_Weapon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *ptr = Get_Current_Translated_Weapon(Commands->Find_Object(lnpop(L, 1)));
	if(!ptr)
	{
		return 0;
	}
	lpushs(L, ptr);
	delete []ptr;
	return 1;
}
int Lua_Get_Team_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *ptr = Get_Team_Name(lnpop(L, 1));
	if(!ptr)
	{
		return 0;
	}
	lpushs(L, ptr);
	delete []ptr;
	return 1;
}
int Lua_Get_Vehicle_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *ptr = Get_Vehicle_Name(Commands->Find_Object(lnpop(L, 1)));
	if(!ptr)
	{
		return 0;
	}
	lpushs(L, ptr);
	delete []ptr;
	return 1;
}
int Lua_Get_Translated_Definition_Name(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *ptr = Get_Translated_Definition_Name(lspop(L, 1));
	if(!ptr)
	{
		return 0;
	}
	lpushs(L, ptr);
	delete []ptr;
	return 1;
}
int Lua_Get_Current_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Current_Bullets(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Current_Clip_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Current_Clip_Bullets(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Current_Total_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Current_Total_Bullets(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Total_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Total_Bullets(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2)));
	return 1;
}
int Lua_Get_Clip_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Clip_Bullets(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2)));
	return 1;
}
int Lua_Get_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Bullets(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2)));
	return 1;
}
int Lua_Get_Current_Max_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Current_Max_Bullets(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Current_Clip_Max_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Current_Clip_Max_Bullets(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Current_Total_Max_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Current_Total_Max_Bullets(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Max_Total_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Max_Total_Bullets(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2)));
	return 1;
}
int Lua_Get_Max_Clip_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Max_Total_Bullets(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2)));
	return 1;
}
int Lua_Get_Max_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Max_Bullets(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2)));
	return 1;
}
int Lua_Get_Position_Total_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Position_Total_Bullets(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)));
	return 1;
}
int Lua_Get_Position_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Position_Bullets(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)));
	return 1;
}
int Lua_Get_Position_Clip_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Position_Clip_Bullets(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)));
	return 1;
}
int Lua_Get_Position_Total_Max_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Position_Total_Max_Bullets(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)));
	return 1;
}
int Lua_Get_Position_Max_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Position_Max_Bullets(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)));
	return 1;
}
int Lua_Get_Position_Clip_Max_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Position_Clip_Max_Bullets(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)));
	return 1;
}
int Lua_Set_Current_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Current_Bullets(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	return 0;
}
int Lua_Set_Current_Clip_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Set_Current_Clip_Bullets(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
	return 0;
}
int Lua_Set_Position_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Set_Position_Bullets(Commands->Find_Object(lnpop(L, 3)), lnpop(L, 1), lnpop(L, 2));
	return 0;
}
int Lua_Set_Position_Clip_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Set_Position_Clip_Bullets(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2), lnpop(L, 3));
	return 0;
}
int Lua_Set_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Set_Bullets(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2), lnpop(L, 3));
	return 0;
}
int Lua_Set_Clip_Bullets(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Set_Clip_Bullets(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2), lnpop(L, 3));
	return 0;
}
int Lua_Get_Powerup_Weapon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushs(L, Get_Powerup_Weapon(lspop(L, 1)));
	return 1;
}
/*
int Lua_Get_Weapon_Ammo_Definition(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_Get_Current_Weapon_Ammo_Definition(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_Get_Position_Weapon_Ammo_Definition(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_Get_Weapon_Definition(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_Get_Current_Weapon_Definition(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
int Lua_Get_Position_Weapon_Definition(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}


int Lua_Get_Explosion(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < )
	{
		return 0;
	}

	return 0;
}
*/
int Lua_Get_Powerup_Weapon_By_Obj(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushs(L, Get_Powerup_Weapon_By_Obj(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Current_Weapon_Style(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Current_Weapon_Style(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Get_Position_Weapon_Style(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Position_Weapon_Style(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)));
	return 1;
}
int Get_Weapon_Style(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_Weapon_Style(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2)));
	return 1;
}
int Lua_Disarm_Beacon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Disarm_Beacon(Commands->Find_Object(lnpop(L, 1)));
	return 0;
}
int Lua_Disarm_Beacons(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Disarm_Beacons(lnpop(L, 1));
	return 0;
}
int Lua_Disarm_Nearest_Beacon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Disarm_Nearest_Beacon(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2), lnpop(L, 3));
	return 0;
}
int Lua_Disarm_C4(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Disarm_C4(Commands->Find_Object(lnpop(L, 1)));
	return 0;
}
int Lua_Disarm_All_Proxy_C4(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Disarm_All_Proxy_C4(lnpop(L, 1));
	return 0;
}
int Lua_Disarm_All_C4(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	Disarm_All_C4(lnpop(L, 1));
	return 0;
}
int Lua_Get_Current_Weapon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushs(L, Get_Current_Weapon(Commands->Find_Object(lnpop(L, 1))));
	return 0;
}
int Lua_Get_Weapon_Count(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Weapon_Count(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_Weapon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushs(L, Get_Weapon(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2)));
	return 1;
}
int Lua_Has_Weapon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Has_Weapon(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2)));
	return 1;
}
int Lua_Find_Beacon(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	lpushn(L, Get_ID(Find_Beacon(lnpop(L, 1), lnpop(L, 2))));
	return 1;
}
int Lua_Get_C4_Count(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_C4_Count(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Beacon_Count(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_Beacon_Count(lnpop(L, 1)));
	return 1;
}
int Lua_Get_Mine_Limit(lua_State *L)
{
	lpushn(L, Get_Mine_Limit());
	return 1;
}
int Lua_Get_C4_Mode(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_C4_Mode(Commands->Find_Object(lnpop(L, 1))));
	return 1;
}
int Lua_Get_C4_Count_Proximity(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_C4_Count_Proximity(lnpop(L, 1)));
	return 1;
}
int Lua_Get_C4_Count_Remote(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_C4_Count_Remote(lnpop(L, 1)));
	return 1;
}
int Lua_Get_C4_Planter(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_C4_Planter(Commands->Find_Object(lnpop(L, 1)))));
	return 1;
}
int Lua_Get_C4_Attached(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_C4_Attached(Commands->Find_Object(lnpop(L, 1)))));
	return 1;
}
int Lua_Get_Beacon_Planter(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	lpushn(L, Get_ID(Get_Beacon_Planter(Commands->Find_Object(lnpop(L, 1)))));
	return 1;
}

int Lua_Create_Object(lua_State *L)
{
  int argc = lua_gettop(L);
  if(argc < 2)
  {
	return 0;
  }
  LUA_Vector3 *a = LuaVector3::GetInstance(L, 2);
  Vector3 pos = Vector3(a->GetX(), a->GetY(), a->GetZ());
  GameObject *obj = Commands->Create_Object(lspop(L, 1), pos);
  if(obj)
  {
	  lpushn(L, Get_ID(obj));
  }
  else
  {
	  return 0;
  }
  return 1;
}
int Lua_Destroy_Object(lua_State *L)
{
   int argc = lua_gettop(L);
  if(argc < 1)
  {
	return 0;
  }
  Commands->Destroy_Object(Commands->Find_Object(lnpop(L, 1)));
  return 0;
}

int Lua_Get_Preset_Name(lua_State *L)
{
   int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	const char *ptr = Commands->Get_Preset_Name(Commands->Find_Object(lnpop(L, 1)));
	if(!ptr)
	{
		return 0;
	}
	lpushs(L, ptr);
	return 1;
}

int Lua_Get_Position(lua_State *L)
{
   int argc = lua_gettop(L);
  if(argc < 1)
  {
	return 0;
  }
  Vector3 pos = Commands->Get_Position(Commands->Find_Object(lnpop(L, 1)));
  LUA_Vector3 *a = new LUA_Vector3(pos.X, pos.Y, pos.Z);
  lua_boxpointer(L, a);
  luaL_getmetatable(L, "Vector3");
  lua_setmetatable(L, -2);

  return 1;
}
int Lua_Enable_Vehicle_Transitions(lua_State *L)
{
  int argc = lua_gettop(L);
  if(argc < 1)
  {
	return 0;
  }
  Commands->Enable_Vehicle_Transitions(Commands->Find_Object(lnpop(L, 1)), lnpop(L, 2));
  return 0;
}

int Lua_Set_Model(lua_State *L)
{
  int argc = lua_gettop(L);
  if(argc < 2)
  {
	return 0;
  }
  Commands->Set_Model(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2));
  return 0;
}

int Lua_Goto_Location(lua_State *L)
{
  int argc = lua_gettop(L);
  if(argc < 7)
  {
	return 0;
  }
  ActionParamsStruct aps;
  aps.Set_Goto_Location(Vector3(lnpop(L, 2), lnpop(L, 3), lnpop(L, 4)), lnpop(L, 5), lnpop(L, 6), lnpop(L, 7));
  Commands->Action_Goto(Commands->Find_Object(lnpop(L, 1)), aps); 
  return 0;
}
int Lua_Goto_Object(lua_State *L)
{
  int argc = lua_gettop(L);
  if(argc < 4)
  {
	return 0;
  }
  ActionParamsStruct aps;
  aps.Set_Goto(Commands->Find_Object(lnpop(L, 2)), lnpop(L, 3), lnpop(L,4));
  Commands->Action_Goto(Commands->Find_Object(lnpop(L, 1)), aps); 
  return 0;
}

int Lua_Disable_Physical_Collisions(lua_State *L)
{
  int argc = lua_gettop(L);
   if(argc < 1)
  {
	return 0;
  }
	Commands->Disable_Physical_Collisions(Commands->Find_Object(lnpop(L, 1)));
  return 0;
}

int Lua_Enable_Collisions(lua_State *L)
{
  int argc = lua_gettop(L);
   if(argc < 1)
  {
	return 0;
  }
	Commands->Enable_Collisions(Commands->Find_Object(lnpop(L, 1)));
  return 0;
}

int Lua_Random_Building(lua_State *L)
{
	GameObject *obj = Find_Building(Commands->Get_Random_Int(0, 1), Commands->Get_Random_Int(0, 9));
	while(!obj)
	{
		obj = Find_Building(Commands->Get_Random_Int(0, 1), Commands->Get_Random_Int(0, 9));
	}
	lua_pushnumber(L, Commands->Get_ID(obj));
	return 1;
}
int Lua_Get_Current_Map(lua_State *L)
{
	lua_pushstring(L, The_Game()->MapName);
	return 1;
}
int Lua_Get_Next_Map(lua_State *L)
{
	lua_pushstring(L, (The_Game()->MapList[The_Game()->MapNumber+1] == 0 ? The_Game()->MapList[0] : The_Game()->MapList[The_Game()->MapNumber+1]));
	return 1;
}
int Lua_Set_Position(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	LUA_Vector3 *a = LuaVector3::GetInstance(L, 2);
	Vector3 pos = Vector3(a->X(), a->Y(), a->Z());
	GameObject *obj = Commands->Find_Object(lua_tonumber(L, 1));
	Commands->Set_Position(obj, pos);
	return 0;
}
int Lua_Apply_Damage(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	GameObject *obj = Commands->Find_Object(lua_tonumber(L, 1));
	float amount = (float)lua_tonumber(L, 2);
	const char *type = lua_tostring(L, 3);
	GameObject *obj2 = (argc > 3 ? Commands->Find_Object(lua_tonumber(L, 4)) : 0);
	Commands->Apply_Damage(obj, amount, type, obj2);
	return 0;
}
int Lua_Get_Facing(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 1)
	{
		return 0;
	}
	GameObject *obj = Commands->Find_Object(lua_tonumber(L, 1));
	lua_pushnumber(L, Commands->Get_Facing(obj));
	return 1;
}
int Lua_Set_Facing(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	GameObject *obj = Commands->Find_Object(lua_tonumber(L, 1));
	float facing = (float)lua_tonumber(L, 2);
	Commands->Set_Facing(obj, facing);
	return 0;
}

int Lua_Set_Clouds(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Commands->Set_Clouds(lnpop(L, 1), lnpop(L, 2), lnpop(L, 3));
	return 0;
}
int Lua_Set_Ash(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	bool enable = (lua_tonumber(L, 3) > 0 ? 1 : 0);
	Commands->Set_Ash(lnpop(L, 1), lnpop(L, 2), enable);
	return 0;
}
int Lua_Set_Rain(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	bool enable = (lua_tonumber(L, 3) > 0 ? 1 : 0);
	Commands->Set_Snow(lnpop(L, 1), lnpop(L, 2), enable);
	return 0;
}
int Lua_Set_Snow(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	bool enable = (lua_tonumber(L, 3) > 0 ? 1 : 0);
	Commands->Set_Snow(lnpop(L, 1), lnpop(L, 2), enable);
	return 0;
}
int Lua_Set_Wind(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 4)
	{
		return 0;
	}
	Commands->Set_Wind(lnpop(L, 1), lnpop(L, 2), lnpop(L, 3), lnpop(L, 4));
	return 0;
}
int Lua_Attach_Script(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Commands->Attach_Script(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2), lspop(L, 3));
	return 0;
}
int Lua_Create_Object_At_Bone(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	lua_pushnumber(L, Commands->Get_ID(Commands->Create_Object_At_Bone(Commands->Find_Object(lnpop(L, 1)), lspop(L, 2), lspop(L, 3))));
	return 1;
}
int Lua_Attach_To_Object_Bone(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 3)
	{
		return 0;
	}
	Commands->Attach_To_Object_Bone(Commands->Find_Object(lnpop(L, 1)), Commands->Find_Object(lnpop(L, 2)), lspop(L, 3));
	return 0;
}
int Lua_Display_Health_Bar(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	bool enable = (lua_tonumber(L, 2) > 0 ? 1 : 0);
	Commands->Display_Health_Bar(Commands->Find_Object(lnpop(L, 1)), enable);
	return 0;
}

int Lua_Create_Script_Zone(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}
	Box *a = LuaBox::GetInstance(L, 2);
	OBBoxClass box;
	for(int i = 0; i < 3; i++)
	{
		for(int y = 0; y < 3; y++)
		{
			box.Basis[i][y] = a->box.Basis[i][y];
		}
	}
	box.Center = a->box.Center;
	box.Extent = a->box.Extent;
	lua_pushnumber(L, Commands->Get_ID(Create_Zone(lspop(L, 1), box)));
	return 1;
}

int Lua_tClock(lua_State *L)
{
	lua_pushnumber(L, clock());
	return 1;
}

int Lua_Invoke(lua_State *L)
{
	int argc = lua_gettop(L);
	if(argc < 2)
	{
		return 0;
	}

	LuaManager::CallInvoke(lua_tostring(L, 1), lua_tostring(L, 2));
	return 0;
}


void AddFunctions(lua_State *L)
{
	lua_register(L, "Console_Input",Lua_Console_Input);
	lua_register(L, "Console_Output",Lua_Console_Output);
	lua_register(L, "Get_Definition_Name",Lua_Get_Definition_Name);
	lua_register(L, "Get_Definition_ID",Lua_Get_Definition_ID);
	lua_register(L, "Get_Definition_Class_ID",Lua_Get_Definition_Class_ID);
	lua_register(L, "Is_Valid_Preset_ID",Lua_Is_Valid_Preset_ID);
	lua_register(L, "Is_Valid_Preset",Lua_Is_Valid_Preset);
	lua_register(L, "Set_Max_Health",Lua_Set_Max_Health);
	lua_register(L, "Set_Max_Shield_Strength",Lua_Set_Max_Shield_Strength);
	lua_register(L, "Get_Shield_Type",Lua_Get_Shield_Type);
	lua_register(L, "Get_Skin",Lua_Get_Skin);
	lua_register(L, "Set_Skin",Lua_Set_Skin);
	lua_register(L, "Power_Base",Lua_Power_Base); 
	lua_register(L, "Set_Can_Generate_Soldiers",Lua_Set_Can_Generate_Soldiers);
	lua_register(L, "Set_Can_Generate_Vehicles",Lua_Set_Can_Generate_Vehicles); 
	lua_register(L, "Destroy_Base",Lua_Destroy_Base);
	lua_register(L, "Beacon_Destroyed_Base",Lua_Beacon_Destroyed_Base);
	lua_register(L, "Enable_Base_Radar",Lua_Enable_Base_Radar);
	lua_register(L, "Is_Harvester",Lua_Is_Harvester);
	lua_register(L, "Is_Radar_Enabled",Lua_Is_Radar_Enabled); 
	lua_register(L, "Building_Type",Lua_Building_Type); 
	lua_register(L, "Is_Building_Dead",Lua_Is_Building_Dead); 
	lua_register(L, "Find_Building",Lua_Find_Building);
	lua_register(L, "Find_Base_Defense",Lua_Find_Base_Defense);
	lua_register(L, "Is_Map_Flying",Lua_Is_Map_Flying); 
	lua_register(L, "Find_Harvester",Lua_Find_Harvester);
	lua_register(L, "Is_Base_Powered",Lua_Is_Base_Powered);
	lua_register(L, "Can_Generate_Vehicles",Lua_Can_Generate_Vehicles);
	lua_register(L, "Can_Generate_Soliders",Lua_Can_Generate_Soliders);
	lua_register(L, "Is_A_Building",Lua_Is_A_Building);
	lua_register(L, "Get_Building_Count_Team",Lua_Get_Building_Count_Team);
	lua_register(L, "Find_Building_By_Team",Lua_Find_Building_By_Team);
	lua_register(L, "Find_Building_By_Name",Lua_Find_Building_By_Name);
	lua_register(L, "Find_Power_Plant",Lua_Find_Power_Plant);
	lua_register(L, "Find_Refinery",Lua_Find_Refinery);
	lua_register(L, "Find_Repair_Bay",Lua_Find_Repair_Bay);
	lua_register(L, "Find_Soldier_Factory",Lua_Find_Soldier_Factory);
	lua_register(L, "Find_Airstrip",Lua_Find_Airstrip);
	lua_register(L, "Find_War_Factory",Lua_Find_War_Factory);
	lua_register(L, "Find_Vehicle_Factory",Lua_Find_Vehicle_Factory);
	lua_register(L, "Find_Com_Center",Lua_Find_Com_Center);
	lua_register(L, "Is_Gameplay_Permitted",Lua_Is_Gameplay_Permitted);
	lua_register(L, "Is_Dedicated",Lua_Is_Dedicated); 
	lua_register(L, "Is_Linux",Lua_Is_Linux);
	lua_register(L, "Get_Current_Game_Mode",Lua_Get_Current_Game_Mode);
	lua_register(L, "Get_Harvester_Preset_ID",Lua_Get_Harvester_Preset_ID);
	lua_register(L, "Is_Harvester_Preset",Lua_Is_Harvester_Preset);
	lua_register(L, "Destroy_Connection",Lua_Destroy_Connection);
	lua_register(L, "Get_IP_Address",Lua_Get_IP_Address);
	lua_register(L, "Get_IP_Port",Lua_Get_IP_Port);
	lua_register(L, "Get_Bandwidth",Lua_Get_Bandwidth);
	lua_register(L, "Get_Ping",Lua_Get_Ping);
	lua_register(L, "Get_Kbits",Lua_Get_Kbits);
	lua_register(L, "Get_Object_Type",Lua_Get_Object_Type);
	lua_register(L, "Set_Object_Type(",Lua_Set_Object_Type);
	lua_register(L, "Is_Building",Lua_Is_Building);
	lua_register(L, "Is_Soldier",Lua_Is_Soldier);
	lua_register(L, "Is_Vehicle",Lua_Is_Vehicle);
	lua_register(L, "Is_Cinematic",Lua_Is_Cinematic);
	lua_register(L, "Is_ScriptZone",Lua_Is_ScriptZone);
	lua_register(L, "Is_Powerup",Lua_Is_Powerup);
	lua_register(L, "Is_C4",Lua_Is_C4);
	lua_register(L, "Is_Beacon",Lua_Is_Beacon);
	lua_register(L, "Is_Armed",Lua_Is_Armed);
	lua_register(L, "Is_Simple",Lua_Is_Simple);
	lua_register(L, "Is_PowerPlant",Lua_Is_PowerPlant);
	lua_register(L, "Is_SoldierFactory",Lua_Is_SoldierFactory);
	lua_register(L, "Is_VehicleFactory",Lua_Is_VehicleFactory);
	lua_register(L, "Is_Airstrip",Lua_Is_Airstrip);
	lua_register(L, "Is_WarFactory",Lua_Is_WarFactory);
	lua_register(L, "Is_Refinery",Lua_Is_Refinery);
	lua_register(L, "Is_ComCenter",Lua_Is_ComCenter);
	lua_register(L, "Is_RepairBay",Lua_Is_RepairBay);
	lua_register(L, "Is_Scriptable",Lua_Is_Scriptable);
	lua_register(L, "Get_Building_Type",Lua_Get_Building_Type);
	lua_register(L, "Get_Object_Count",Lua_Get_Object_Count);
	lua_register(L, "Find_Random_Preset",Lua_Find_Random_Preset);
	lua_register(L, "Send_Custom_To_Team_Buildings",Lua_Send_Custom_To_Team_Buildings);
	lua_register(L, "Send_Custom_To_Team_Preset",Lua_Send_Custom_To_Team_Preset);
	lua_register(L, "Send_Custom_All_Objects",Lua_Send_Custom_All_Objects);
	lua_register(L, "Send_Custom_Event_To_Object",Lua_Send_Custom_Event_To_Object);
	lua_register(L, "Get_Is_Powerup_Persistant",Lua_Get_Is_Powerup_Persistant);
	lua_register(L, "Set_Is_Powerup_Persistant",Lua_Set_Is_Powerup_Persistant);
	lua_register(L, "Get_Powerup_Always_Allow_Grant",Lua_Get_Powerup_Always_Allow_Grant);
	lua_register(L, "Set_Powerup_Always_Allow_Grant",Lua_Set_Powerup_Always_Allow_Grant);
	lua_register(L, "Get_Powerup_Grant_Sound",Lua_Get_Powerup_Grant_Sound);
	lua_register(L, "Set_Powerup_Grant_Sound",Lua_Set_Powerup_Grant_Sound);
	lua_register(L, "Grant_Powerup",Lua_Grant_Powerup);
	lua_register(L, "Get_Vehicle",Lua_Get_Vehicle);
	lua_register(L, "Grant_Refill",Lua_Grant_Refill);
	lua_register(L, "Change_Character",Lua_Change_Character);
	lua_register(L, "Create_Vehicle",Lua_Create_Vehicle);
	lua_register(L, "Toggle_Fly_Mode",Lua_Toggle_Fly_Mode);
	lua_register(L, "Get_Vehicle_Occupant_Count",Lua_Get_Vehicle_Occupant_Count);
	lua_register(L, "Get_Vehicle_Occupant",Lua_Get_Vehicle_Occupant);
	lua_register(L, "Get_Vehicle_Driver",Lua_Get_Vehicle_Driver);
	lua_register(L, "Get_Vehicle_Gunner",Lua_Get_Vehicle_Gunner);
	lua_register(L, "Force_Occupant_Exit",Lua_Force_Occupant_Exit);
	lua_register(L, "Force_Occupants_Exit",Lua_Force_Occupants_Exit);
	lua_register(L, "Get_Vehicle_Return",Lua_Get_Vehicle_Return);
	lua_register(L, "Is_Stealth",Lua_Is_Stealth);
	lua_register(L, "Get_Fly_Mode",Lua_Get_Fly_Mode);
	lua_register(L, "Get_Vehicle_Seat_Count",Lua_Get_Vehicle_Seat_Count);
	lua_register(L, "Get_Spawn_Char",Lua_Get_Spawn_Char);
	lua_register(L, "Change_Spawn_Char",Lua_Change_Spawn_Char);
	lua_register(L, "Soldier_Transition_Vehicle",Lua_Soldier_Transition_Vehicle);
	lua_register(L, "Get_Vehicle_Mode",Lua_Get_Vehicle_Mode);
	lua_register(L, "Get_Team_Vehicle_Count",Lua_Get_Team_Vehicle_Count);
	lua_register(L, "Get_Vehicle_Owner",Lua_Get_Vehicle_Owner);
	lua_register(L, "Force_Occupants_Exit_Team",Lua_Force_Occupants_Exit_Team);
	lua_register(L, "Get_Vehicle_Definition_Mode",Lua_Get_Vehicle_Definition_Mode);
	lua_register(L, "IsInsideZone",Lua_IsInsideZone);
	lua_register(L, "Get_Vehicle_Definition_Mode_By_ID",Lua_Get_Vehicle_Definition_Mode_By_ID);
	lua_register(L, "Get_Zone_Type",Lua_Get_Zone_Type);
	lua_register(L, "IsAvailableForPurchase",Lua_IsAvailableForPurchase);
	lua_register(L, "Check_Transitions",Lua_Check_Transitions);
	lua_register(L, "Get_Vehicle_Gunner_Pos",Lua_Get_Vehicle_Gunner_Pos);
	lua_register(L, "Set_Vehicle_Is_Visible",Lua_Set_Vehicle_Is_Visible);
	lua_register(L, "Set_Vehicle_Gunner",Lua_Set_Vehicle_Gunner);
	lua_register(L, "Get_Model",Lua_Get_Model);
	lua_register(L, "Get_Animation_Frame",Lua_Get_Animation_Frame);
	lua_register(L, "Is_TrackedVehicle",Lua_Is_TrackedVehicle);
	lua_register(L, "Is_VTOLVehicle",Lua_Is_VTOLVehicle);
	lua_register(L, "Is_WheeledVehicle",Lua_Is_WheeledVehicle);
	lua_register(L, "Is_Motorcycle",Lua_Is_Motorcycle);
	lua_register(L, "Is_Door",Lua_Is_Door);
	lua_register(L, "Is_Elevator",Lua_Is_Elevator);
	lua_register(L, "Is_DamageableStaticPhys",Lua_Is_DamageableStaticPhys);
	lua_register(L, "Is_AccessablePhys",Lua_Is_AccessablePhys);
	lua_register(L, "Is_DecorationPhys",Lua_Is_DecorationPhys);
	lua_register(L, "Is_HumanPhys",Lua_Is_HumanPhys);
	lua_register(L, "Is_MotorVehicle",Lua_Is_MotorVehicle);
	lua_register(L, "Is_Phys3",Lua_Is_Phys3);
	lua_register(L, "Is_RigidBody",Lua_Is_RigidBody);
	lua_register(L, "Is_ShakeableStatricPhys",Lua_Is_ShakeableStatricPhys);
	lua_register(L, "Is_StaticAnimPhys",Lua_Is_StaticAnimPhys);
	lua_register(L, "Is_StaticPhys",Lua_Is_StaticPhys);
	lua_register(L, "Is_TimedDecorationPhys",Lua_Is_TimedDecorationPhys);
	lua_register(L, "Is_VehiclePhys",Lua_Is_VehiclePhys);
	lua_register(L, "Is_DynamicAnimPhys",Lua_Is_DynamicAnimPhys);
	lua_register(L, "Is_BuildingAggregate",Lua_Is_BuildingAggregate);
	lua_register(L, "Is_Projectile",Lua_Is_Projectile);
	lua_register(L, "Get_Physics",Lua_Get_Physics);
	lua_register(L, "Copy_Transform",Lua_Copy_Transform);
	lua_register(L, "Get_Mass",Lua_Get_Mass);
	lua_register(L, "Get_Htree_Name",Lua_Get_Htree_Name);
	lua_register(L, "Get_Sex",Lua_Get_Sex);
	lua_register(L, "Create_Effect_All_Of_Preset",Lua_Create_Effect_All_Of_Preset);
	lua_register(L, "Get_GameObj",Lua_Get_GameObj);
	lua_register(L, "Get_Player_ID",Lua_Get_Player_ID);
	lua_register(L, "Get_Player_Name",Lua_Get_Player_Name);
	lua_register(L, "Get_Player_Name_By_ID",Lua_Get_Player_Name_By_ID);
	lua_register(L, "Change_Team",Lua_Change_Team);
	lua_register(L, "Change_Team_By_ID",Lua_Change_Team_By_ID);
	lua_register(L, "Get_Player_Count",Lua_Get_Player_Count);
	lua_register(L, "Get_Team_Player_Count",Lua_Get_Team_Player_Count);
	lua_register(L, "Get_Team",Lua_Get_Team);
	lua_register(L, "Get_Rank",Lua_Get_Rank);
	lua_register(L, "Get_Kills",Lua_Get_Kills);
	lua_register(L, "Get_Deaths",Lua_Get_Deaths);
	lua_register(L, "Get_Score",Lua_Get_Score);
	lua_register(L, "Get_Money",Lua_Get_Money);
	lua_register(L, "Get_Kill_To_Death_Ratio",Lua_Get_Kill_To_Death_Ratio);
	lua_register(L, "Get_Part_Name",Lua_Get_Part_Name);
	lua_register(L, "Get_Part_Names",Lua_Get_Part_Names);
	lua_register(L, "Get_GameObj_By_Player_Name",Lua_Get_GameObj_By_Player_Name);
	lua_register(L, "Purchase_Item",Lua_Purchase_Item);
	lua_register(L, "Set_Ladder_Points",Lua_Set_Ladder_Points);
	lua_register(L, "Set_Rung",Lua_Set_Rung);
	lua_register(L, "Set_Money",Lua_Set_Money);
	lua_register(L, "Set_Score",Lua_Set_Score);
	lua_register(L, "Find_First_Player",Lua_Find_First_Player);
	lua_register(L, "Change_Player_Team",Lua_Change_Player_Team);
	lua_register(L, "Tally_Team_Size",Lua_Tally_Team_Size);
	lua_register(L, "Get_Team_Score",Lua_Get_Team_Score);
	lua_register(L, "Send_Custom_All_Players",Lua_Send_Custom_All_Players);
	lua_register(L, "Steal_Team_Credits",Lua_Steal_Team_Credits);
	lua_register(L, "Get_Team_Credits",Lua_Get_Team_Credits);
	lua_register(L, "Change_Team_2",Lua_Change_Team_2);
	lua_register(L, "Get_Player_Type",Lua_Get_Player_Type);
	lua_register(L, "Get_Team_Cost",Lua_Get_Team_Cost);
	lua_register(L, "Get_Cost",Lua_Get_Cost);
	lua_register(L, "Set_Enlisted",Lua_Set_Enlisted);
	lua_register(L, "Set_Beacon",Lua_Set_Beacon);
	lua_register(L, "Set_Refill",Lua_Set_Refill);
	lua_register(L, "Set_Preset",Lua_Set_Preset);
	lua_register(L, "Set_Alternate",Lua_Set_Alternate);
	lua_register(L, "Disable_Enlisted",Lua_Disable_Enlisted);
	lua_register(L, "Disable_Preset",Lua_Disable_Preset);
	lua_register(L, "Disable_Enlisted_By_Name",Lua_Disable_Enlisted_By_Name);
	lua_register(L, "Disable_Preset_By_Name",Lua_Disable_Preset_By_Name);
	lua_register(L, "Disable_All_Ground_Vehicles",Lua_Disable_All_Ground_Vehicles);
	lua_register(L, "Disable_All_Flying_Vehicles",Lua_Disable_All_Flying_Vehicles);
	lua_register(L, "Get_Team_Icon",Lua_Get_Team_Icon);
	lua_register(L, "Get_Icon",Lua_Get_Icon);
	lua_register(L, "Remove_Script",Lua_Remove_Script);
	lua_register(L, "Remove_All_Scripts",Lua_Remove_All_Scripts);
	lua_register(L, "Attach_Script_Preset",Lua_Attach_Script_Preset);
	lua_register(L, "Attach_Script_Type",Lua_Attach_Script_Type);
	lua_register(L, "Remove_Script_Preset",Lua_Remove_Script_Preset);
	lua_register(L, "Remove_Script_Type",Lua_Remove_Script_Type);
	lua_register(L, "Is_Script_Attached",Lua_Is_Script_Attached);
	lua_register(L, "Attach_Script_Once",Lua_Attach_Script_Once);
	lua_register(L, "Attach_Script_Preset_Once",Lua_Attach_Script_Preset_Once);
	lua_register(L, "Attach_Script_Type_Once",Lua_Attach_Script_Type_Once);
	lua_register(L, "Attach_Script_Building",Lua_Attach_Script_Building);
	lua_register(L, "Attach_Script_Is_Preset",Lua_Attach_Script_Is_Preset);
	lua_register(L, "Attach_Script_Is_Type",Lua_Attach_Script_Is_Type);
	lua_register(L, "Attach_Script_Player_Once",Lua_Attach_Script_Player_Once);
	lua_register(L, "Remove_Duplicate_Script",Lua_Remove_Duplicate_Script);
	lua_register(L, "Attach_Script_All_Buildings_Team",Lua_Attach_Script_All_Buildings_Team);
	lua_register(L, "Attach_Script_All_Turrets_Team",Lua_Attach_Script_All_Turrets_Team);
	lua_register(L, "Find_Building_With_Script",Lua_Find_Building_With_Script);
	lua_register(L, "Find_Object_With_Script",Lua_Find_Object_With_Script);
	lua_register(L, "Get_Translated_String",Lua_Get_Translated_String);
	lua_register(L, "Get_Translated_Preset_Name",Lua_Get_Translated_Preset_Name);
	lua_register(L, "Get_Translated_Weapon",Lua_Get_Translated_Weapon);
	lua_register(L, "Get_Current_Translated_Weapon",Lua_Get_Current_Translated_Weapon);
	lua_register(L, "Get_Team_Name",Lua_Get_Team_Name);
	lua_register(L, "Get_Vehicle_Name",Lua_Get_Vehicle_Name);
	lua_register(L, "Get_Translated_Definition_Name",Lua_Get_Translated_Definition_Name);
	lua_register(L, "Get_Current_Bullets",Lua_Get_Current_Bullets);
	lua_register(L, "Get_Current_Clip_Bullets",Lua_Get_Current_Clip_Bullets);
	lua_register(L, "Get_Current_Total_Bullets",Lua_Get_Current_Total_Bullets);
	lua_register(L, "Get_Total_Bullets",Lua_Get_Total_Bullets);
	lua_register(L, "Get_Clip_Bullets",Lua_Get_Clip_Bullets);
	lua_register(L, "Get_Bullets",Lua_Get_Bullets);
	lua_register(L, "Get_Current_Max_Bullets",Lua_Get_Current_Max_Bullets);
	lua_register(L, "Get_Current_Clip_Max_Bullets",Lua_Get_Current_Clip_Max_Bullets);
	lua_register(L, "Get_Current_Total_Max_Bullets",Lua_Get_Current_Total_Max_Bullets);
	lua_register(L, "Get_Max_Total_Bullets",Lua_Get_Max_Total_Bullets);
	lua_register(L, "Get_Max_Clip_Bullets",Lua_Get_Max_Clip_Bullets);
	lua_register(L, "Get_Max_Bullets",Lua_Get_Max_Bullets);
	lua_register(L, "Get_Position_Total_Bullets",Lua_Get_Position_Total_Bullets);
	lua_register(L, "Get_Position_Bullets",Lua_Get_Position_Bullets);
	lua_register(L, "Get_Position_Clip_Bullets",Lua_Get_Position_Clip_Bullets);
	lua_register(L, "Get_Position_Total_Max_Bullets",Lua_Get_Position_Total_Max_Bullets);
	lua_register(L, "Get_Position_Max_Bullets",Lua_Get_Position_Max_Bullets);
	lua_register(L, "Get_Position_Clip_Max_Bullets",Lua_Get_Position_Clip_Max_Bullets);
	lua_register(L, "Set_Current_Bullets",Lua_Set_Current_Bullets);
	lua_register(L, "Set_Current_Clip_Bullets",Lua_Set_Current_Clip_Bullets);
	lua_register(L, "Set_Position_Bullets",Lua_Set_Position_Bullets);
	lua_register(L, "Set_Position_Clip_Bullets",Lua_Set_Position_Clip_Bullets);
	lua_register(L, "Set_Bullets",Lua_Set_Bullets);
	lua_register(L, "Set_Clip_Bullets",Lua_Set_Clip_Bullets);
	lua_register(L, "Get_Powerup_Weapon",Lua_Get_Powerup_Weapon);
	lua_register(L, "Get_Powerup_Weapon_By_Obj",Lua_Get_Powerup_Weapon_By_Obj);
	lua_register(L, "Get_Current_Weapon_Style",Lua_Get_Current_Weapon_Style);
	lua_register(L, "Disarm_Beacon",Lua_Disarm_Beacon);
	lua_register(L, "Disarm_Beacons",Lua_Disarm_Beacons);
	lua_register(L, "Disarm_Nearest_Beacon",Lua_Disarm_Nearest_Beacon);
	lua_register(L, "Disarm_C4",Lua_Disarm_C4);
	lua_register(L, "Disarm_All_Proxy_C4",Lua_Disarm_All_Proxy_C4);
	lua_register(L, "Disarm_All_C4",Lua_Disarm_All_C4);
	lua_register(L, "Get_Current_Weapon",Lua_Get_Current_Weapon);
	lua_register(L, "Get_Weapon_Count",Lua_Get_Weapon_Count);
	lua_register(L, "Get_Weapon",Lua_Get_Weapon);
	lua_register(L, "Has_Weapon",Lua_Has_Weapon);
	lua_register(L, "Find_Beacon",Lua_Find_Beacon);
	lua_register(L, "Get_C4_Count",Lua_Get_C4_Count);
	lua_register(L, "Get_Beacon_Count",Lua_Get_Beacon_Count);
	lua_register(L, "Get_Mine_Limit",Lua_Get_Mine_Limit);
	lua_register(L, "Get_C4_Mode",Lua_Get_C4_Mode);
	lua_register(L, "Get_C4_Count_Proximity",Lua_Get_C4_Count_Proximity);
	lua_register(L, "Get_C4_Count_Remote",Lua_Get_C4_Count_Remote);
	lua_register(L, "Get_C4_Planter",Lua_Get_C4_Planter);
	lua_register(L, "Get_C4_Attached",Lua_Get_C4_Attached);
	lua_register(L, "Get_Beacon_Planter",Lua_Get_Beacon_Planter);

	lua_register(L, "Create_Object",Lua_Create_Object);
	lua_register(L, "Destroy_Object",Lua_Destroy_Object);
	lua_register(L, "Get_Preset_Name",Lua_Get_Preset_Name);
	lua_register(L, "Get_Position",Lua_Get_Position);
	lua_register(L, "Enable_Vehicle_Transitions", Lua_Enable_Vehicle_Transitions);
	lua_register(L, "Set_Model",Lua_Set_Model);
	lua_register(L, "Goto_Location",Lua_Goto_Location);
	lua_register(L, "Goto_Object",Lua_Goto_Object);
	lua_register(L, "Disable_Physical_Collisions", Lua_Disable_Physical_Collisions);
	lua_register(L, "Enable_Collisions", Lua_Enable_Collisions);

	lua_register(L, "Random_Building", Lua_Random_Building);

	lua_register(L, "Get_Current_Map", Lua_Get_Current_Map);
	lua_register(L, "Get_Next_Map", Lua_Get_Next_Map);
	lua_register(L, "Set_Position", Lua_Set_Position);
	lua_register(L, "Apply_Damage", Lua_Apply_Damage);
	lua_register(L, "Get_Facing", Lua_Get_Facing);
	lua_register(L, "Set_Facing", Lua_Set_Facing);
	lua_register(L, "Set_Clouds", Lua_Set_Clouds);
	lua_register(L, "Set_Ash", Lua_Set_Ash);
	lua_register(L, "Set_Rain", Lua_Set_Rain);
	lua_register(L, "Set_Snow", Lua_Set_Snow);
	lua_register(L, "Set_Wind", Lua_Set_Wind);
	lua_register(L, "Attach_Script", Lua_Attach_Script);
	lua_register(L, "Create_Object_At_Bone", Lua_Create_Object_At_Bone);
	lua_register(L, "Attach_To_Object_Bone", Lua_Attach_To_Object_Bone);
	lua_register(L, "Display_Health_Bar", Lua_Display_Health_Bar);
	lua_register(L, "Create_Script_Zone", Lua_Create_Script_Zone);
	lua_register(L, "Get_ID", Lua_Get_ID);
	lua_register(L, "tClock", Lua_tClock);
	lua_register(L, "Invoke", Lua_Invoke);
  
  //Classes
	LuaVector3::Register(L);
	LuaBox::Register(L);

}